using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.AI.Entity
 {
    [TypeScript]
    [Table("ai_sentence")]
    public class AiSentenceEntity : EntityBase<string>
    {

    public AiSentenceEntity() 
    {
    }

    [Column("person_name")]
    public string? PersonName  { get; set; }
    [Column("gender")]
    public string? Gender  { get; set; }
    [Column("sentiment")]
    public string? Sentiment  { get; set; }
    [Column("content")]
    public string Content  { get; set; }
    [Column("status")]
    public string? Status  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("guid")]
    public string Guid  { get; set; }
    [Column("paragraph_guid")]
    public string ParagraphGuid  { get; set; }
    [Column("sentence_index")]
    public int SentenceIndex  { get; set; }
    [Column("dialogue_indc")]
    public string DialogueIndc  { get; set; }
    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }

    public const string PERSON_NAME = "PersonName";
    public const string GENDER = "Gender";
    public const string SENTIMENT = "Sentiment";
    public const string CONTENT = "Content";
    public const string STATUS = "Status";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string GUID = "Guid";
    public const string PARAGRAPH_GUID = "ParagraphGuid";
    public const string SENTENCE_INDEX = "SentenceIndex";
    public const string DIALOGUE_INDC = "DialogueIndc";
    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";

    public const string DB_NAME_AI_SENTENCE = "ai_sentence";
    public const string DB_NAME_FIELDS="person_name,gender,sentiment,content,status,updated_datetime,updated_by,guid,paragraph_guid,sentence_index,dialogue_indc,created_datetime,created_by";

    public const string DB_PERSON_NAME = "person_name";
    public const string DB_GENDER = "gender";
    public const string DB_SENTIMENT = "sentiment";
    public const string DB_CONTENT = "content";
    public const string DB_STATUS = "status";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_GUID = "guid";
    public const string DB_PARAGRAPH_GUID = "paragraph_guid";
    public const string DB_SENTENCE_INDEX = "sentence_index";
    public const string DB_DIALOGUE_INDC = "dialogue_indc";
    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";


    public static AiSentenceEntity GetInstance()
    {
        return new AiSentenceEntity();
    }

    public virtual void CopyFrom(AiSentenceEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(AiSentenceEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.PersonName =  source.PersonName;
        this.Gender =  source.Gender;
        this.Sentiment =  source.Sentiment;
        this.Content =  source.Content;
        this.Status =  source.Status;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.Guid =  source.Guid;
        this.ParagraphGuid =  source.ParagraphGuid;
        this.SentenceIndex =  source.SentenceIndex;
        this.DialogueIndc =  source.DialogueIndc;
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;

        if (includeSystemFields)
        {
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_AI_SENTENCE}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_AI_SENTENCE}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_GUID ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_AI_SENTENCE}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public AiSentenceEntity Clone()
    {
        AiSentenceEntity result = new AiSentenceEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
